---
title: CanvasRenderingContext2D.setLineDash()
slug: Web/API/CanvasRenderingContext2D/setLineDash
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Dashes
  - LInes
  - Method
  - Reference
  - patterns
  - setLineDash
---
<div>{{APIRef}}</div>

<p>The <strong><code>setLineDash()</code></strong> method of the Canvas 2D API's {{domxref("CanvasRenderingContext2D")}} interface sets the line dash pattern used when stroking lines. It uses an array of values that specify alternating lengths of lines and gaps which describe the pattern.</p>

<div class="note">
<p><strong>Note:</strong> To return to using solid lines, set the line dash list to an empty array.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.setLineDash(<em>segments</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code>segments</code></dt>
	<dd>An {{jsxref("Array")}} of numbers that specify distances to alternately draw a line and a gap (in coordinate space units). If the number of elements in the array is odd, the elements of the array get copied and concatenated. For example, <code>[5, 15, 25]</code> will become <code>[5, 15, 25, 5, 15, 25]</code>. If the array is empty, the line dash list is cleared and line strokes return to being solid.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<p>This example uses the <code>setLineDash()</code> method to draw a dashed line above a solid line.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[6, 13]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Dashed line
ctx.beginPath();
ctx.setLineDash([5, 15]);
ctx.moveTo(0, 50);
ctx.lineTo(300, 50);
ctx.stroke();

// Solid line
ctx.beginPath();
ctx.setLineDash([]);
ctx.moveTo(0, 100);
ctx.lineTo(300, 100);
ctx.stroke();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Basic_example', 700, 180) }}</p>

<h3 id="Some_common_patterns">Some common patterns</h3>

<p>This example illustrates a variety of common line dash patterns.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>The <code>drawDashedLine()</code> function created below makes the drawing of multiple dashed lines simple. It receives a pattern array as its only parameter.</p>

<pre class="brush: js">function drawDashedLine(pattern) {
  ctx.beginPath();
  ctx.setLineDash(pattern);
  ctx.moveTo(0, y);
  ctx.lineTo(300, y);
  ctx.stroke();
  y += 20;
}

const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
let y = 15;

drawDashedLine([]);
drawDashedLine([1, 1]);
drawDashedLine([10, 10]);
drawDashedLine([20, 5]);
drawDashedLine([15, 3, 3, 3]);
drawDashedLine([20, 3, 3, 3, 3, 3, 3, 3]);
drawDashedLine([12, 3, 3]);  // Equals [12, 3, 3, 12, 3, 3]

</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Some_common_patterns', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-setlinedash", "CanvasRenderingContext2D.setLineDash")}}</td>
			<td>{{Spec2('HTML WHATWG')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.setLineDash")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
	<li>{{domxref("CanvasRenderingContext2D.getLineDash()")}}</li>
	<li>{{domxref("CanvasRenderingContext2D.lineDashOffset")}}</li>
</ul>
